%if 0%{?rhel} == 7
  %bcond_without libwrap
%else
  %bcond_with libwrap
%endif

Name:           conserver
Version:        8.2.7
Release:    1%{?dist}
Summary:        Serial console server daemon/client

License:        BSD-3-Clause AND Zlib
URL:            https://www.%{name}.com

Source0:        https://github.com/bstansell/%{name}/releases/download/v%{version}/%{name}-%{version}.tar.gz
Source1:        https://github.com/bstansell/%{name}/releases/download/v%{version}/%{name}-%{version}.tar.gz.asc
Source2:        bstansell-gpg-key.asc

Source3:        %{name}.service

Patch0:         %{name}-no-exampledir.patch
Patch1:         %{name}-8.2.7-buffer-overflow.patch

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  freeipmi-devel
BuildRequires:  gcc
BuildRequires:  gnupg2
BuildRequires:  krb5-devel
BuildRequires:  make
BuildRequires:  openssl-devel
BuildRequires:  pam-devel
BuildRequires:  sed
BuildRequires:  systemd-rpm-macros
%if %{with libwrap}
BuildRequires:  tcp_wrappers-devel
%endif

%description
Conserver is an application that allows multiple users to watch a serial
console at the same time.  It can log the data, allows users to take
write-access of a console (one at a time), and has a variety of bells
and whistles to accentuate that basic functionality.

%package client
Summary: Serial console client

%description client
This is the client package needed to interact with a Conserver daemon.

%prep
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%autosetup -p1

find . -name Makefile.in -exec \
       sed -i 's/@INSTALL_PROGRAM@ -s/@INSTALL_PROGRAM@/g' {} \;

%build
%configure --with-freeipmi   \
           --with-gssapi     \
%if %{with libwrap}
           --with-libwrap    \
%endif
           --with-openssl    \
           --with-pam        \
           --with-port=782   \
           --with-striprealm
%make_build

%install
%make_install

mkdir -p %{buildroot}%{_sysconfdir}
for cfg in conserver.{cf,passwd}; do
  sed -e 's/^/#/' "conserver.cf/$cfg" > "%{buildroot}%{_sysconfdir}/$cfg"
done

install -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/conserver.service

%check
%make_build test

%post
%systemd_post conserver.service

%preun
%systemd_preun conserver.service

%postun
%systemd_postun_with_restart conserver.service

%files
%doc CHANGES FAQ PROTOCOL README.md
%doc conserver.cf/{conserver.{cf,passwd},samples/}
%license LICENSE
%config(noreplace) %{_sysconfdir}/conserver.*
%{_unitdir}/conserver.service
%{_libdir}/conserver
%{_mandir}/man5/conserver.cf.5*
%{_mandir}/man5/conserver.passwd.5*
%{_mandir}/man8/conserver.8*
%{_sbindir}/conserver

%files client
%license LICENSE
%{_bindir}/console
%{_mandir}/man1/console.1*

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 8.2.7-1
- initial build
